#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "linkedstack.h"

LinkedStack* createLinkedStack()
{
	LinkedStack *pReturn = NULL;
	
	pReturn = (LinkedStack*)malloc(sizeof(LinkedStack));
	if(pReturn != NULL)
	{
		memset(pReturn, 0, sizeof(LinkedStack));
	}
	else
	{
		printf("pReturn Ҵ  ! createLinkedStack() Error!\n");
		
		return NULL;
	}
	
	return pReturn;
}

int pushLS(LinkedStack *pStack, StackNode element)
{
	int ret = FALSE;
	
	StackNode *pNewNode = NULL;
	
	if( pStack != NULL )
	{
		pNewNode = (StackNode*)malloc(sizeof(StackNode));
		if(pNewNode != NULL)
		{
			*pNewNode = element;
			//pNewNode->pLink = NULL;
						
			pNewNode->pLink = pStack->pTopElement;
			pStack->pTopElement = pNewNode;
			
			pStack->curElementCnt++;
			ret = TRUE;
		}
		else
		{
			printf("pNewNode Ҵ  ! pushLS() Error!\n");
		}
	}
	
	return ret;
}

StackNode* popLS(LinkedStack *pStack)
{
	StackNode* pReturn = NULL;

	if(pStack != NULL)
	{
		if( isLinkedStackEmpty(pStack) == FALSE )
		{
			pReturn = pStack->pTopElement;
			pStack->pTopElement = pStack->pTopElement->pLink;
			//pStack->pTopElemnt = pReturn->pLink;
			pReturn->pLink = NULL;

			pStack->curElementCnt--;
		}
		else
		{
			printf("Stack !! \n");

			return NULL;
		}
	}

	return pReturn;
}

StackNode* peekLS(LinkedStack *pStack)
{
	StackNode* pReturn = NULL;

	if( pStack != NULL )
	{
		if( isLinkedStackEmpty(pStack) == FALSE )
		{
			pReturn = pStack->pTopElement;
		}
		else
		{
			printf("Stack ! \n");
			
			return NULL;
		}
	}

	return pReturn;
}

void deleteLinkedStack(LinkedStack *pStack)
{
	StackNode* pDelNode = NULL;

	if( pStack != NULL )
	{
		while(pStack->pTopElement != NULL)
		{
			pDelNode = pStack->pTopElement;
			pStack->pTopElement = pDelNode->pLink;
			free(pDelNode);
		}

		free(pStack);
	}
}

int isLinkedStackFull(LinkedStack *pStack)
{
	int ret = FALSE;

	return ret;
}

int isLinkedStackEmpty(LinkedStack *pStack)
{
	int ret = FALSE;

	if( pStack != NULL )
	{
		if( pStack->curElementCnt == 0 )
			ret = TRUE;
	}

	return ret;
}

void displayLinkedStack(LinkedStack *pStack)
{
	int count = 0;
	StackNode* pNode = NULL;

	if( pStack != NULL )
	{
		pNode = pStack->pTopElement;
		count = pStack->curElementCnt-1;

		printf("   : %d \n", pStack->curElementCnt);
		
		while(pNode != NULL)
		{
			printf("[%d] : %c \n", count, pNode->data);

			count--;
			pNode = pNode->pLink;
		}

		puts("");
	}

}